import bb.cascades 1.0

Page {
    id: root
    property string bigcount: '?'
    property int counter: 0

    Container {
        Label {
            text: "main.qml bundled in app"
        }

        Button {
            text: "Send Msg to Python"
            onClicked: {
                console.log('tart.postMessage():');
                var rc = tart.postMessage(JSON.stringify({msg: 'qml-message', count: ++root.counter}));
                console.log('tart.postMessage() --> ' + rc);
            }
        }

        Button {
            text: "Kill Python"
            onClicked: {
                var rc = tart.postMessage(JSON.stringify({msg: 'kill'}));
            }
        }

        Label {
            text: 'Count: ' + root.counter + ', Count*5 (from Python): ' + root.bigcount
        }

        ImageView {
            id: image
            preferredWidth: 300
            preferredHeight: 300
        }

        Button {
            text: "Quit"
            onClicked: {
                console.log('quitting time');
                Application.quit()
            }
        }
    }

    function onMessage(msg) {
        console.log('qml got ' + msg);
        var data = JSON.parse(msg);
        for (var k in data)
            console.log('  ' + k + ': ' + data[k] + ' [' + typeof data[k] + ']');
        if (data.msg == 'echo') {
            root.bigcount = '-' + data['count*5'] + '-';
        }
    }

    onCreationCompleted: {
        tart.messageYielded.connect(onMessage);
    }
}
