import sys
import datetime as dt
import time
import threading
import json

import tart

print('importing blackberry_tart.py')


#~ def log(msg):
    #~ with open('shared/misc/blackberry_tart.log', 'a') as outf:
        #~ outf.write(msg)
        #~ outf.write('\n')


done = False

def run_thread():
    print('2nd thread started')
    time.sleep(1)
    print(time.time(), '2nd thread 1')

    tart.send(json.dumps({'foo': 'testmsg', 'pi': 3.14}))

    while not done:
        sys.stdout.flush()
        time.sleep(2)
        print(time.time(), '2nd thread awoke')

    tart.send(json.dumps({'msg': 'done delay'}))

    #~ print(time.time(), '2nd thread ending', threading.active_count())
    print('secondary thread finished')
    sys.stdout.flush()


if __name__ == '__main__':
    #~ log('{} starting'.format(dt.datetime.now()))
    print('this is a test', sys.version)

    print('tart module', tart)
    print('tart.number()', tart.number())

    sys.stdout.flush()
    time.sleep(1)
    t = threading.Thread(target=run_thread)
    t.daemon = True
    t.start()

    # raising SystemExit seems to crash with a segfault, so for now work around
    # by catching that and converting to a simple flag
    _systemExitWorkaround = False
    try:
        while 1:
            print(time.time(), 'main thread waiting')
            sys.stdout.flush()
            try:
                msg = tart.wait()
            except SystemExit:
                #~ open('/accounts/1000/shared/misc/crash.log','w').write('{} crashed!\n'.format(dt.datetime.now()))
                print(time.time(), 'system exit!')
                sys.stdout.flush()
                raise

            print(time.time(), 'new msg', msg)
            if msg == 1:
                raise SystemExit('exit from py')
                break

            try:
                data = json.loads(msg)
            except ValueError:
                data = {}

            if data.get('msg') == 'kill':
                tart.send(json.dumps({'msg': 'okay, exiting'}))
                break

            elif data.get('msg') == 'qml-message':
                count = data.get('count', 0)
                print('count', count)
                if count == 3:
                    done = True

                tart.send(json.dumps({'msg': 'echo', 'count*5': count * 5}))

        log('{} exiting'.format(dt.datetime.now()))
        sys.stdout.flush()

    except SystemExit:
        _systemExitWorkaround = True

    finally:
        done = True
        #~ if _systemExitWorkaround:
            #~ open('/accounts/1000/shared/misc/crash.log','a').write('exiting\n')
